package fxHarakka.luokat;


/**
 * ----------Yksittäisen projektin luokka------------
 * |
 * | - Ei tiedä muista luokista mitään.
 * | - Huolehtii yksittäisen projektin kentistä eli:
 * |       -aihe
 * |       -nimi
 * |       -kesto (viikoissa)
 * |       -suoritettu (viikoissa)
 * | - Osaa get metodit omille attribuuteille.
 * | - Osaa parsia itsensä merkkijonoksi
 * --------------------------------------------------
 */
public class Projekti {

    private String aihe;        //projektin aihealue
    private String nimi;        //projektin nimi
    private int id;       //projekti id --> ensimmäinen projekti alkaa id nro 1
    private int kesto;
    private int suoritettu;
    private static int seuraavaNro = 1;


    //default parametritön muodostaja
    public Projekti() {
        this.id = 0;
        this.nimi = "";
        this.aihe = "";
    }
    //minimimuodostaja. kestoa tai suoritettua ei vielä ilmoitettu
    public Projekti(String nimi, String aihe) {
        this.id = 0;
        this.nimi = nimi;
        this.aihe = aihe;
    }

    //parametrillinen muodostaja
    public Projekti(int id, String nimi, String aihe){
        this.id = id;
        this.nimi = nimi;
        this.aihe = aihe;
    }



    //-----------------------Metodit ja Funktiot - PROJEKTI----------------------------



    /** Aliohjelma joka antaa projektille id numeron
     *
     * @example <pre name="test">
     *
     * Projekti projekti1 = new Projekti("Projekti1", "Fysiikka");
     * Projekti projekti2 = new Projekti("Projekti2", "Kemia");
     * projekti1.rekisteroiProjekti();
     * projekti2.rekisteroiProjekti();
     * projekti1.toString() === "Projekti1 | Fysiikka | 1";
     * projekti2.toString() === "Projekti2 | Kemia | 2"
     * </pre>
     *
     *
     * </pre>
     */
    public void rekisteroiProjekti(){
        int nro = seuraavaNro++; // huom jälkilisäys
        this.id = nro;

    }




    /**
     *
     * @return palauttaa projektin id numeron
     */
    public int getId() {
        return id;
    }

    /**
     *
     * @return palauttaa projektin nimen
     */
    public String getNimi() {
        return nimi;
    }

    /**
     *
     * @return palauttaa projektin aiheen
     */
    public String getAihe() {
        return aihe;
    }

    public void setAihe(String aihe){
     this.aihe = aihe;
    }

    public void setNimi(String nimi){
        this.nimi = nimi;
    }

    public void setKesto(int kesto){
        this.kesto = kesto;
    }

    public void setSuoritettu(int suoritettu){
        this.suoritettu = suoritettu;
    }

    @Override
    public String toString(){
        String strg = this.nimi + " | " + this.aihe + " | " + this.id + " | " + this.kesto + " | " + this.suoritettu;

        return strg;
    }

    //maini testaamista varten
    public static void main(String[] args){



    }


}
